3 # Multi-build script for testing compilation of all maintained
6 # Copyright 2002 Free Software Foundation, Inc.
8 # Contributed by Richard Earnshaw (rearnsha@arm.com)
10 # This program is free software; you can redistribute it and/or modify
11 # it under the terms of the GNU General Public License as published by
12 # the Free Software Foundation; either version 2 of the License, or
13 # (at your option) any later version.
15 # This program is distributed in the hope that it will be useful,
16 # but WITHOUT ANY WARRANTY; without even the implied warranty of
17 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18 # GNU General Public License for more details.
20 # You should have received a copy of the GNU General Public License
21 # along with this program; if not, write to the Free Software
22 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
27 Usage: gdb_mbuild.sh [ <options> ... ] <srcdir> <builddir>
29 -j <makejobs> Run <makejobs> in parallel. Passed to make.
30 On a single cpu machine, 2 is recommended.
31 -k Keep going. Do not stop after the first build fails.
32 -e <regexp> Regular expression for selecting the targets to build.
33 -f Force rebuild. Even rebuild previously built directories.
34 -v Be more (and more, and more) verbose.
36 <srcdir> Source code directory.
37 <builddir> Build directory.
38 Environment variables examined (with default if not defined):
43 -b <maxbuilds> Run <maxbuild> builds in parallel.
44 On a single cpu machine, 1 is recommended.
48 ### COMMAND LINE OPTIONS
60 # Number of parallel make jobs.
62 test $# -ge 1 || usage
66 # Number of builds to fire off in parallel.
68 test $# -ge 1 || usage
72 # Should we soldier on after the first build fails?
76 # A regular expression for selecting targets
78 test $# -ge 1 || usage
79 targexp="${targexp} -e ${1}"
85 # Be more, and more, and more, verbose
86 verbose=`expr ${verbose} + 1`
95 ### COMMAND LINE PARAMETERS
102 # Convert these to absolute directory paths.
104 # Where the sources live
105 srcdir=`cd $1 && /bin/pwd` || exit 1
107 # Where the builds occur
108 builddir=`cd $2 && /bin/pwd` || exit 1
110 ### ENVIRONMENT PARAMETERS
112 # Version of make to use
118 # Where to look for the list of targets to test
119 maintainers=${srcdir}/gdb/MAINTAINERS
120 if [ ! -r ${maintainers} ]
122 echo Maintainers file ${maintainers} not found
126 # Get the list of targets and the build options
127 alltarg=`cat ${maintainers} | tr -s '[\t]' '[ ]' | sed -n '
128 /^[ ]*[-a-z0-9\.]*[ ]*[(]*--target=.*/ !d
143 ' | if test "${targexp}" = ""
145 grep -v -e broken -e OBSOLETE
151 # Usage: fail <message> <test-that-should-succeed>. Should the build
152 # fail? If the test is true, and we don't want to keep going, print
153 # the message and shoot everything in sight and abort the build.
160 echo "${target}: ${msg}"
161 if test "${keepgoing}" != ""
173 # Usage: log <level> <logfile>. Write standard input to <logfile> and
174 # stdout (if verbose >= level).
178 if test ${verbose} -ge $1
188 # Warn the user of what is comming, print the list of targets
194 # For each target, configure, build and test it.
196 echo "$alltarg" | while read target gdbopts simopts
200 dir=${builddir}/${target}
202 # Should a scratch rebuild be forced, for perhaphs the entire
207 echo forcing ${target} ...
217 # Did the previous configure attempt fail? If it did
218 # restart from scratch.
220 if test -d ${dir} -a ! -r ${dir}/Makefile
222 echo ... removing partially configured ${target}
226 echo "${target}: unable to remove directory ${dir}"
231 # From now on, we're in this target's build directory
236 # Configure, if not already. Should this go back to being
237 # separate and done in parallel?
239 if test ! -r Makefile
241 # Default SIMOPTS to GDBOPTS.
242 test -z "${simopts}" && simopts="${gdbopts}"
244 __target="--target=${target}"
245 __enable_gdb_build_warnings=`test -z "${gdbopts}" \
246 || echo "--enable-gdb-build-warnings=${gdbopts}"`
247 __enable_sim_build_warnings=`test -z "${simopts}" \
248 || echo "--enable-sim-build-warnings=${simopts}"`
249 __configure="${srcdir}/configure \
251 ${__enable_gdb_build_warnings} \
252 ${__enable_sim_build_warnings}"
253 echo ... ${__configure}
254 trap "echo Removing partially configured ${dir} directory ...; rm -rf ${dir}; exit 1" 1 2 15
255 ${__configure} 2>&1 | log 2 Config.log
258 fail "configure failed" ! -r Makefile
260 # Build, if not built.
262 if test ! -x gdb/gdb -a ! -x gdb/gdb.exe
264 echo ... ${make} ${keepgoing} ${makejobs} ${target}
265 ${make} ${keepgoing} ${makejobs} all-gdb 2>&1 | log 1 Build.log
267 fail "compile failed" ! -x gdb/gdb -a ! -x gdb/gdb.exe
269 # Check that the built GDB can at least print it's architecture.
271 echo ... run ${target}
272 rm -f core gdb.core ${dir}/gdb/x
274 maint print architecture
277 ./gdb/gdb -batch -nx -x x 2>&1 | log 1 Gdb.log
278 fail "gdb dumped core" -r core -o -r gdb.core
279 fail "gdb printed no output" ! -s Gdb.log
280 grep -e internal-error Gdb.log && fail "gdb panic" 1
282 echo ... cleanup ${target}
284 # Create a sed script that cleans up the output from GDB.
286 touch mbuild.sed || exit 1
288 # Rules to replace <0xNNNN> with the corresponding function's
290 sed -n -e '/<0x0*>/d' -e 's/^.*<0x\([0-9a-f]*\)>.*$/0x\1/p' Gdb.log \
294 func="`addr2line -f -e ./gdb/gdb -s ${addr} | sed -n -e 1p`"
295 test ${verbose} -gt 0 && echo "${addr} ${func}" 1>&2
296 echo "s/<${addr}>/<${func}>/g"
299 # Rules to strip the leading paths off of file names.
300 echo 's/"\/.*\/gdb\//"gdb\//g' >> mbuild.sed
302 # Replace the build directory with a file as semaphore that stops
303 # a rebuild. (should the logs be saved?)
307 sed -f ${target}/mbuild.sed ${target}/Gdb.log > ${target}.tmp
309 mv ${target}.tmp ${target}
312 echo ... ${target} built